unit _Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBCtrls, Db, DBTables, Grids, DBGrids, html_template,
  activex_shell, ComObj, shellapi, ExtCtrls;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Query1: TQuery;
    DataSource2: TDataSource;
    Query2: TQuery;
    DBGrid2: TDBGrid;
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    HTML_Template1: Thtml_template;
    SaveDialog1: TSaveDialog;
    RadioGroup1: TRadioGroup;
    procedure HTML_Template1ScriptRun(Sender: TObject; script: String);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure HTML_Template1OpenURLError(Sender: TObject; URL,
      ErrorMessage: String);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation


{$R *.DFM}


procedure TForm1.FormCreate(Sender: TObject);
begin
  ChDir( ExtractFilePath(ParamStr(0)) );
end;


function check_by_guid(component_guid: String): Boolean;
 var v : Variant;
begin

  try
    v := CreateCOMObject(StringToGUID(component_guid));
    result := True;
  except
    result := False;
  end;

end;


procedure TForm1.HTML_Template1ScriptRun(Sender: TObject; script: String);
  var scripting : Variant;
begin


// checkin that all compoenents are installed

  if not check_by_guid('{EE09B103-97E0-11CF-978F-00A02463E06F}') then begin
    ShowMessage('First install MS ActiveX Scripting.' + #13#13 + 'See  index.html  -> [ MS ActiveX Scripting ]');
    Exit;
  end;

  if not check_by_guid('{0E59F1D5-1FBE-11D0-8FF2-00A0D10038BC}') then begin
    ShowMessage('First install MS Script Control.' + #13#13 + 'See  index.html  -> [ MS ActiveX Scripting ]');
    Exit;

  end;

// creating an instance of MS Script Control

  try
    scripting := CreateOLEObject('ScriptControl');
  except
    ShowMessage('MS ScriptControl is not installed.' + #13#13 + 'See index.html about downloading and installation.');
    Exit;
  end;

  scripting.AllowUI  := False;
  scripting.Language := 'VBScript';
  scripting.Timeout  := -1;


// adding an objects to script control's name space

// 1. output object
  scripting.AddObject('Output', obj_to_variant(HTML_Template1.ReportOutput));


// 2. other objects you want be accessible from template page code
  scripting.AddObject('Query1', obj_to_variant(Query1));
  scripting.AddObject('Query2', obj_to_variant(Query2));

// executing the script and receiving report
  scripting.ExecuteStatement(script);

end;

procedure TForm1.HTML_Template1OpenURLError(Sender: TObject; URL, ErrorMessage: String);
begin
  ShowMessage('Can not load URL = ' + URL);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  html_template1.URL := RadioGroup1.Items[RadioGroup1.ItemIndex];
  html_template1.RunScript := False;
  Memo1.Lines.Text := html_template1.prepare;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  html_template1.URL := RadioGroup1.Items[RadioGroup1.ItemIndex];
  html_template1.RunScript := True;

  Query2.DisableControls;

  html_template1.prepare;

  Query2.EnableControls;

  if html_template1.Ready then begin

    Memo1.Lines.Text := html_template1.Text;

    if SaveDialog1.Execute() then begin

      // saving to file

      with TFileStream.Create(SaveDialog1.FileName, fmCreate) do begin
        Write(PChar(html_template1.Text)^,length(html_template1.Text));
        Free;
      end;

      // opening the file with report

      ShellExecute(Application.Handle,
                   PChar('open'),
                   PChar(SaveDialog1.FileName),
                   nil,nil,SW_SHOWNORMAL
                   );


    end;

  end;

end;



end.
